/* This file is an image processing operation for GEGL
 *
 * GEGL is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * GEGL is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with GEGL; if not, see <https://www.gnu.org/licenses/>.
 *
 * Copyright 2006 Øyvind Kolås <pippin@gimp.org>
 * 2023 Beaver, Exotic Bevel Collection


This Gimp plugin can be tested without installing by pasting syntax from g1, g2, g3, g4, ect... into Gimp's GEGL graph.
--

THERE IS NO NEED TO PROVIDE SYNTAX WHEN ALL OF IT IS BELOW in each g definition. Paste each g individually into GEGL graph not all at once.
 */

#include "config.h"
#include <glib/gi18n-lib.h>


#ifdef GEGL_PROPERTIES


#define g1 \
"  id=contain src aux=[ ref=contain levels out-low=0.10 id=1 dst-out aux=[ ref=1 median-blur radius=5 alpha-percentile=0 ssg radius=0 stroke=2 opacityssg=1.8 ssg radius=0 stroke=2  opacityssg=1.8 ssg radius=0 stroke=2  opacityssg=1.8 ssg radius=0 stroke=2 opacityssg=1.8 ssg radius=0 stroke=2  opacityssg=1.8 ssg radius=0 stroke=2  opacityssg=1.8 ssg radius=0 stroke=2 opacityssg=1.8 ssg radius=0 stroke=2  opacityssg=1.8 ssg radius=0 stroke=2  opacityssg=1.8 gaussian-blur std-dev-x=1 std-dev-y=1 ] id=fucky overlay aux=[ ref=fucky emboss depth=1  ] crop median-blur radius=0 id=2 gimp:layer-mode layer-mode=grain-merge composite-mode=clip-to-backdrop opacity=0.5  aux=[  ref=2 lb:bevel type=sharpbevel radius1=7 radius2=0 bevel1=45 bevel2=21 th=0.1 azimuth=40 slideupblack=0 metric=chebyshev smooth=0 ] dst-over  aux=[ ref=contain custom-bevel gaus=1 box=2 ]  median-blur radius=0 "\


#define g2 \
" id=contain src aux=[ ref=contain levels out-low=0.10 id=1 dst-out aux=[ ref=1 median-blur radius=5 alpha-percentile=0 ssg radius=0 stroke=4 opacityssg=1.8 ssg radius=0 stroke=4  opacityssg=1.8 ssg radius=0 stroke=4  opacityssg=1.8 ssg radius=0 stroke=4 opacityssg=1.8 ssg radius=0 stroke=4  opacityssg=1.8 ssg radius=0 stroke=4  opacityssg=1.8 ssg radius=0 stroke=4 opacityssg=1.8 ssg radius=0 stroke=4  opacityssg=1.8 ssg radius=0 stroke=4  opacityssg=1.8 gaussian-blur std-dev-x=1 std-dev-y=1 ] id=fucky overlay aux=[ ref=fucky emboss depth=1  ] crop median-blur radius=0 id=2 gimp:layer-mode layer-mode=grain-merge composite-mode=clip-to-backdrop opacity=0.5  aux=[  ref=2 lb:bevel type=sharpbevel radius1=7 radius2=0 bevel1=45 bevel2=21 th=0.1 azimuth=40 slideupblack=0 metric=chebyshev smooth=0 ] dst-over  aux=[ ref=contain custom-bevel gaus=1 box=2 ]  median-blur radius=0 "\


#define g3 \
" id=contain src aux=[ ref=contain levels out-low=0.10 id=1 dst-out aux=[ ref=1 median-blur radius=5 alpha-percentile=0 ssg radius=0 stroke=6 opacityssg=1.8 ssg radius=0 stroke=6  opacityssg=1.8 ssg radius=0 stroke=6  opacityssg=1.8 ssg radius=0 stroke=6 opacityssg=1.8 ssg radius=0 stroke=6  opacityssg=1.8 ssg radius=0 stroke=6  opacityssg=1.8 ssg radius=0 stroke=6 opacityssg=1.8 ssg radius=0 stroke=6  opacityssg=1.8 ssg radius=0 stroke=6  opacityssg=1.8 gaussian-blur std-dev-x=1 std-dev-y=1 ] id=fucky overlay aux=[ ref=fucky emboss depth=1  ] crop median-blur radius=0 id=2 gimp:layer-mode layer-mode=grain-merge composite-mode=clip-to-backdrop opacity=0.5  aux=[  ref=2 lb:bevel type=sharpbevel radius1=7 radius2=0 bevel1=45 bevel2=21 th=0.1 azimuth=40 slideupblack=0 metric=chebyshev smooth=0 ] dst-over  aux=[ ref=contain custom-bevel gaus=1 box=2 ]  median-blur radius=0 "\

#define g4 \
" id=contain src aux=[ ref=contain levels out-low=0.10 id=1 dst-out aux=[ ref=1 median-blur radius=5 alpha-percentile=0 ssg radius=0 stroke=8 opacityssg=1.8 ssg radius=0 stroke=8  opacityssg=1.8 ssg radius=0 stroke=8  opacityssg=1.8 ssg radius=0 stroke=8 opacityssg=1.8 ssg radius=0 stroke=8  opacityssg=1.8 ssg radius=0 stroke=8  opacityssg=1.8 ssg radius=0 stroke=8 opacityssg=1.8 ssg radius=0 stroke=8  opacityssg=1.8 ssg radius=0 stroke=8  opacityssg=1.8 gaussian-blur std-dev-x=1 std-dev-y=1 ] id=fucky overlay aux=[ ref=fucky emboss depth=1  ] crop median-blur radius=0 id=2 gimp:layer-mode layer-mode=grain-merge composite-mode=clip-to-backdrop opacity=0.5  aux=[  ref=2 lb:bevel type=sharpbevel radius1=7 radius2=0 bevel1=45 bevel2=21 th=0.1 azimuth=40 slideupblack=0 metric=chebyshev smooth=0 ] dst-over  aux=[ ref=contain custom-bevel gaus=1 box=2 ]  median-blur radius=0 "\

#define g5 \
" id=blendit gimp:layer-mode layer-mode=multiply composite-mode=clip-to-backdrop  aux=[ ref=blendit  id=1 gimp:layer-mode layer-mode=normal composite-mode=clip-to-backdrop aux=[color value=#ffffff  opacity value=11 ] gaussian-blur std-dev-x=1 std-dev-y=1 box-blur radius=11 emboss azimuth=44 depth=3 emboss depth=20 elevation=90 emboss elevation=40 depth=00 ] "\


#define g6 \
" id=blendit gimp:layer-mode layer-mode=grain-merge composite-mode=clip-to-backdrop  aux=[ ref=blendit  id=1 gimp:layer-mode layer-mode=normal composite-mode=clip-to-backdrop aux=[color value=#ffffff  opacity value=11 ] gaussian-blur std-dev-x=1 std-dev-y=1 box-blur radius=11 emboss azimuth=44 depth=3 emboss depth=20 elevation=90 emboss elevation=40 depth=00 ] "\


#define g7 \
" lb:ring lb:gold blendmode=colordodge expand=2.5720000000000001 azimuth=67 elevation=10.460000000000001 medianradius=1 huerotate=0 desaturate=1.3999999999999999 light=1 "\


#define g8 \
" distance-transform   threshold-hi=0.7 metric=chebyshev color-to-alpha color=#000000 color-overlay value=#f587ff  id=3 screen aux=[ ref=3  emboss  type=bumpmap azimuth=90 depth=0  elevation=15 ]  gaussian-blur std-dev-x=3 std-dev-y=3 id=3 screen aux=[ ref=3  emboss  type=bumpmap azimuth=90  depth=0    elevation=15 ]  median-blur  percentile=90 alpha-percentile=61 screen aux=[ ref=3  emboss  type=bumpmap azimuth=90  elevation=15 ]  median-blur  percentile=90 alpha-percentile=100 screen aux=[ ref=3  emboss  type=bumpmap azimuth=90   depth=0   elevation=15 ]  opacity value=7 median-blur radius=0 unsharp-mask scale=0.9 median-blur radius=0 "\

#define g9 \
" lb:ring  color-overlay value=#f587ff median-blur  percentile=20 alpha-percentile=30 gaussian-blur std-dev-x=2 std-dev-y=2 id=3 screen aux=[ ref=3  emboss  type=bumpmap azimuth=90  elevation=15 ]  gaussian-blur std-dev-x=2 std-dev-y=2 id=3 screen aux=[ ref=3  emboss  type=bumpmap azimuth=90  elevation=15 ]  screen aux=[ ref=3  emboss  type=bumpmap azimuth=90  elevation=15 ]  opacity value=10 median-blur radius=0 "\

#define g10 \
" id=contain src aux=[ ref=contain levels out-low=0.10 id=1 dst-out aux=[ ref=1 median-blur radius=5 alpha-percentile=0 ssg radius=0 stroke=7 opacityssg=1.53 ssg radius=0 stroke=7 opacityssg=1.53 ssg radius=0 stroke=7 opacityssg=1.53 ] crop median-blur radius=0 id=2 gimp:layer-mode layer-mode=grain-merge composite-mode=clip-to-backdrop opacity=0.5  aux=[  ref=2 lb:bevel type=sharpbevel radius1=7 radius2=0 bevel1=45 bevel2=21 th=0.1 azimuth=40 slideupblack=0 metric=chebyshev smooth=0 ] dst-over  aux=[ ref=contain custom-bevel gaus=1 box=2 ] unsharp-mask scale=0.9 \ median-blur radius=0"\



property_enum (crazybevel, _("Select a crazy bevel effect:"),
    nichebevel, niche_bevel,
    crazy1)
   description  (_("Choose a niche bevel effect from the list. These bevels would be tedious to turn into individual plugins, so they are just all put in a drop down list here."))

property_int  (radius, _("Size Control"), 3)
  value_range (0, 10)
  ui_range    (0, 10)
  ui_meta     ("unit", "pixel-distance")
  description (_("Median Radius for size control of the bevels"))

property_double (saturation, _("Saturation Boost"), 1)
  value_range (0.0, 2.0)
  ui_range    (0.0, 2.0)
  ui_meta     ("unit", "pixel-distance")
  description (_("Intensify Color"))


enum_start (niche_bevel)
  enum_value (crazy1,      "crazy1",
              N_("9 Rings Sharp Bevel (Grain Merge) Size=2"))
  enum_value (crazy2,      "crazy2",
              N_("9 Rings Sharp Bevel (Grain Merge) Size=4"))
  enum_value (crazy3,      "crazy3",
              N_("9 Rings Sharp Bevel (Grain Merge) Size=6"))
  enum_value (crazy4,      "crazy4",
              N_("9 Rings Sharp Bevel (Grain Merge) Size=8"))
  enum_value (crazy5,      "crazy5",
              N_("Deep Carvings (Multiply)"))
  enum_value (crazy6,      "crazy6",
              N_("Deep Carvings (Grain Merge)"))
  enum_value (crazy7,      "crazy7",
              N_("Gold Rings"))
  enum_value (crazy8,      "crazy8",
              N_("Sharp Glossy Balloon"))
  enum_value (crazy9,      "crazy9",
              N_("Ringed Glossy Balloon"))
  enum_value (crazy10,      "crazy10",
              N_("Sharp Bevel + Faint Rings (Grain Merge)"))
enum_end (nichebevel)

#else

#define GEGL_OP_META
#define GEGL_OP_NAME     crazy_bevel_collection
#define GEGL_OP_C_SOURCE crazy_bevel_collection.c

#include "gegl-op.h"

typedef struct
{
 GeglNode *input;
 GeglNode *sizecontrol;
 GeglNode *saturation;
 GeglNode *a;
 GeglNode *b;
 GeglNode *c;
 GeglNode *d;
 GeglNode *e;
 GeglNode *f;
 GeglNode *g;
 GeglNode *h;
 GeglNode *i;
 GeglNode *j;
 GeglNode *output;
}State;


static void attach (GeglOperation *operation)
{
  GeglNode *gegl = operation->node;
  GeglProperties *o = GEGL_PROPERTIES (operation);

  State *state = o->user_data = g_malloc0 (sizeof (State));

  state->input    = gegl_node_get_input_proxy (gegl, "input");
  state->output   = gegl_node_get_output_proxy (gegl, "output");

  state->a    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g1,
                                  NULL);

  state->b    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g2,
                                  NULL);

  state->c    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g3,
                                  NULL);

  state->d    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g4,
                                  NULL);

  state->e    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g5,
                                  NULL);

  state->f    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g6,
                                  NULL);

  state->g    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g7,
                                  NULL);

  state->h    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g8,
                                  NULL);

  state->i    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g9,
                                  NULL);

  state->j    = gegl_node_new_child (gegl,
                                  "operation", "gegl:gegl", "string", g10,
                                  NULL);



  state->saturation    = gegl_node_new_child (gegl,
                                  "operation", "gegl:saturation",
                                  NULL);


  state->sizecontrol    = gegl_node_new_child (gegl,
                                  "operation", "gegl:median-blur", "alpha-percentile", 100.0,
                                  NULL);


  gegl_operation_meta_redirect (operation, "radius",  state->sizecontrol, "radius");
  gegl_operation_meta_redirect (operation, "saturation",  state->saturation, "scale");


} 

static void update_graph (GeglOperation *operation)
{
  GeglProperties *o = GEGL_PROPERTIES (operation);
  State *state = o->user_data;
  if (!state) return;

switch (o->crazybevel) {
        break;
    case crazy1:
  gegl_node_link_many (state->input, state->sizecontrol, state->a, state->saturation, state->output,  NULL);
        break;
    case crazy2:
  gegl_node_link_many (state->input, state->sizecontrol, state->b, state->saturation, state->output,  NULL);
        break;
    case crazy3:
  gegl_node_link_many (state->input, state->sizecontrol, state->c, state->saturation, state->output,  NULL);
        break;
    case crazy4:
  gegl_node_link_many (state->input, state->sizecontrol, state->d, state->saturation, state->output,  NULL);
        break;
    case crazy5:
  gegl_node_link_many (state->input, state->sizecontrol, state->e, state->saturation, state->output,  NULL);
        break;
    case crazy6:
  gegl_node_link_many (state->input, state->sizecontrol, state->f, state->saturation, state->output,  NULL);
        break;
    case crazy7:
  gegl_node_link_many (state->input, state->sizecontrol, state->g, state->saturation, state->output,  NULL);
        break;
    case crazy8:
  gegl_node_link_many (state->input, state->sizecontrol, state->h, state->saturation, state->output,  NULL);
        break;
    case crazy9:
  gegl_node_link_many (state->input, state->sizecontrol, state->i, state->saturation, state->output,  NULL);
        break;
    case crazy10:
  gegl_node_link_many (state->input, state->sizecontrol, state->j, state->saturation, state->output,  NULL);

    }
}


static void
gegl_op_class_init (GeglOpClass *klass)
{
  GeglOperationClass *operation_class;
GeglOperationMetaClass *operation_meta_class = GEGL_OPERATION_META_CLASS (klass);
  operation_class = GEGL_OPERATION_CLASS (klass);

  operation_class->attach = attach;
  operation_meta_class->update = update_graph;

  gegl_operation_class_set_keys (operation_class,
    "name",        "lb:crazybevels",
    "title",       _("Exotic bevel showcase"),
    "reference-hash", "afgjaksharpa3rings",
    "description", _("Collection of Bevel Algorithms that do not fit with any other plugin. I could have made many of these an individual plugins but decided to group them all here."),
    "gimp:menu-path", "<Image>/Filters/Text Styling",
    "gimp:menu-label", _("Bevel Collection"),
    NULL);
}

#endif
